!#************************************************************************
!# E.S.O. - 3.60 Upgrade Project
!#
!# who		when		what
!# ----------	--------	------------------------
!# c.levin	920601		created
!# p.leisy	980808		VLT Software adaptation
!# kbanse	100111		implement verifications
!# kbanse	100407		last moidif
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!#
!#   NAME:	EXTFocusWedge
!# 
!#   SYNOPSIS:	EXTFocusWedge
!#   
!#   DESCRIPTION:	
!#   Computes the Focus Offset to be applied to M2
!#    
!#   ENVIRONMENT:	
!#   PCO must be running together with a background MIDAS session	
!#
!#   RETURN VALUES:
!#   Focus Offset is written in the keyword OUTPUTR(1)
! ------------------------------------------------------
!
! EXTERNAL VARIABLES:
! teloffs, camoffs, signwedg, distwedg
!
defi/par P1 ? C "Name of frame: "

SET/FORMAT I4 F8.3
write/out
write/out "teloffs : " {teloffs}
write/out "conswedg : " {conswedg(1)},{conswedg(2)},{conswedg(3)} "
write/out "camoffs : " {camoffs}
write/out "signwedg : " {signwedg}
write/out "distwedg : " {distwedg}
write/out
defi/loc imag/c/1/60	{P1}
defi/loc dx/r/1/1	{distwedg}
defi/loc dy/r/1/1	0.0
defi/loc dtelf/r/1/1	0.0
defi/loc yleft/r/1/1	0.0
defi/loc yright/r/1/1	0.0
defi/loc dcamf/r/1/1	0.0
! 
clear/ch ov
! 
writ/out "*************************************" 
writ/out "*****  Click on the left stars  *****"
writ/out "*************************************" 
pointage:
echo/off
load {imag} cuts=1000,2000 scale=-2
cent/gau {imag},leftWdg  focleft
sort/tab focleft :ycen
if outputi(1) .eq. 0 then
   write/out
   write/out "Invalid number of coordinates"
   goto pointage
endif
! 
! Add the X offset (dx) for an automatic search on the right images
! Use the already used left table 
comp/tab focleft :xstart = :xstart + {dx}
comp/tab focleft :xend = :xend + {dx}
! 
cent/gau {imag},focleft focright
! 
set/midas output=no	! no output on the screen... or log(4) = 2
stat/tab focleft :ycen
write/keyw rcorr 440.0141,1565.443,1045.8032,450.21387
@@ kcompare wedg010:rcorr outputr 1,4 0.001
yleft = outputr(3)	! mean value
! 
stat/tab focright :ycen
write/keyw rcorr  447.9326,1564.133,1049.7874,443.19293
@@ kcompare wedg020:rcorr outputr 1,4 0.001
yright = outputr(3)	! mean value
set/midas output=yes	! or log(4) = 0
!
! TELESCOPE focus offset
dy = {signwedg} * ({yleft}-{yright})		! mode R

IF {dy} .LT. 3 THEN
   dtelf = {conswedg(1)} * {dy}
ELSE
   IF {dy} .LT. 6 THEN
      dtelf = {conswedg(2)} * {dy}
   ELSE
      dtelf = {conswedg(3)} * {dy}
   ENDIF
ENDIF
!
set/format F9.3
!write/out " COLLIMATOR offset  = " {dc} 
!write/out " GRISM WHEEL offset = " {dw}
!write/out "yleft : " {yleft}
!write/out "yright : " {yright}
! 
write/out " "
write/out " "
write/out "(Yshift = {Yleft}- {Yright}) = {dy}"
write/out " "
write/out " "
write/out "TELESCOPE focus offset = {dtelf}"
write/out " "
!
if obsmode(1:3) .eq. "EFI" then
    define/local dc/r/1/1 0.
    dc = {grconst} * {dy}
    write/out "For focus wedge calibration:"
    set/format F8.2
    write/out "Offset of grism wheel = {dc}"
endif
! 
outputr(1) = dy
outputr(2) = dtelf
write/key rcorr -3.984,-191.232,
@@ kcompare wedg030:rcorr outputr 1,2 0.0005


! ****************************
! output for Templates
! ****************************
outputR(1) = {dtelf}

clear/ch ov

